
// Dlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include <setupapi.h>

#define MAX_EEROM_DEV	4
#define WM_FTDEVICE		WM_USER+1
#define FTDEVICE_REMOVE	0
#define FTDEVICE_ADD	1
#define WM_INITDEVICES	WM_USER+2

// 512K
#define MAX_MEM_SIZE	5
#define MAX_MEM_SIZE_S	"5"
#define MEM_SIZE_SECT	"MemSize"
#define FILE_NAME_SECT	"FileName"
#define TGT_NAME_SECT	"TargetName"

// connect sequence
#define DEV_CONN_BYTE1	0x87
#define DEV_CONN_BYTE2	0xE9
#define DEV_CONN_BYTE3	0x5D
#define DEV_CONN_BYTE4	0x93
#define DEV_CONN_BYTE5	0xB7
#define DEV_CONN_BYTE6	0x57
#define DEV_UPLOAD1		0x99
#define DEV_UPLOAD2		0x51
#define DEV_DOWNLOAD1	0x7D
#define DEV_DOWNLOAD2	0x3B

#define DEVICE_ACK		0xAA
#define DEVICE_NACK		0x55

struct TENUMDEV
{
	DWORD dwFlags;
	FT_HANDLE ftHandle;
	CString szSerial;
};

struct TDEVICE
{
	HTREEITEM hTreeItem;
	DWORD dwFlags;
	FT_HANDLE ftHandle;
	UINT nMemSize;
	CString szSerial;
	CString szFileName;
	CString szTgtName;
	BOOL bReady;
};

class CTransfer;

// CDlg dialog
class CDlg : public CDialogEx
{
// Construction
public:
	CDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_EEROM_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	HDEVNOTIFY m_hDevNotify1;
	HDEVNOTIFY m_hDevNotify2;
	// the root item of the tree control
	HTREEITEM m_hRoot;
	DWORD m_dwCount;
	DWORD m_dwEnumCount, m_dwEnumAll;
	TENUMDEV m_gEnumDev[MAX_EEROM_DEV];
	TDEVICE* m_gpDevice[MAX_EEROM_DEV];

	DWORD SearchDevice(LPCSTR pszSerial);
	DWORD SearchEnumeratedDevice(LPCSTR pszSerial);
	BOOL AddDevice(DWORD dwIndex);
	BOOL RemoveDevice(DWORD dwIndex);
	void SetMemSizeLabel(LPSTR szBuf, UINT nSize, UINT nMemSize);
	void UpdateMemSizeIni(LPCSTR szSerial, UINT nMemSize);
	void SetFileNameLabel(LPSTR szBuf, UINT nSize, LPCSTR szPath);
	void UpdateFileNameIni(LPCSTR szSerial, LPCSTR szPath);
	void SetTgtNameLabel(LPSTR szBuf, UINT nSize, LPCSTR szTgtName);
	void UpdateTgtNameIni(LPCSTR szSerial, LPCSTR szTgtName);
	BOOL DeviceConnect(TDEVICE *pDev);
	BOOL DeviceWrite(FT_HANDLE ftHandle, LPBYTE pBuf, DWORD dwBytesToWrite, DWORD& dwBytesWritten);
	BOOL DeviceRead(TDEVICE* pDev, LPBYTE pBuf, DWORD dwBytesToRead);
	BOOL DeviceAck(FT_HANDLE ftHandle);
	void UploadFile(TDEVICE *pDev);
	void DownloadFile(TDEVICE *pDev);
	DWORD GetMemSize(TDEVICE *pDev);
	BOOL SendCommand(FT_HANDLE ftHandle, BOOL bUpload, BYTE nPages, BYTE nBlk);
	void TransferDlg(LPCSTR szText);

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg BOOL OnDeviceChange(UINT EventType, DWORD dwData);
	DECLARE_MESSAGE_MAP()
public:
	BOOL EnumDevices();
	CTreeCtrl m_DevTree;
	CTransfer* m_pTransfer;
public:
	virtual BOOL DestroyWindow();
	afx_msg LRESULT OnFTDevice(WPARAM wParam, LPARAM lParam);
	afx_msg void OnRclickDevTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg LRESULT OnInitDevices(WPARAM wParam, LPARAM lParam);
};
